program calculat;

uses dos,crt;


var
  getal_1,getal_2,
  totaal            :real;
  getal             :byte;
  som               :string[5];
  eindtotaal        :real;
  bk                :byte;
  p,x,q             :integer;
  s,ss              :string;
  ch                :char;
  regs              :registers;


procedure cursor_off;

begin
  regs.ax :=$0100;regs.cx :=$2607;intr(16,regs);
end;

procedure cursor_on;

begin
  regs.ax :=$0100;regs.cx :=$0506;intr(16,regs);
end;

procedure fillscreen(character,color :byte);

begin
  regs.ah :=9;
  regs.al :=character;
  regs.bh :=0;
  regs.bl :=color;
  regs.ch :=7;
  regs.cl :=208;
  intr(16,regs);
  textbackground(0);
end;

procedure asci_tekst(x,y :byte;str :string;kleur,achtergrondkleur : Byte);

begin
  textbackground(achtergrondkleur);
  textcolor(kleur);
  gotoxy(x,y);write(str);
  textbackground(0);
end;

procedure asciver(x,y,yy,karakter,kleur :byte);

begin
  textcolor(kleur);
  for p :=y to yy do begin
    gotoxy(x,p);write(chr(karakter));
  end;
end;

procedure ascihor(x,y :byte;aantal :integer;karakter,kleur :byte);

begin
  textcolor(kleur);gotoxy(x,y);
  for p :=1 to aantal do write(chr(karakter));
end;


procedure calculator;

label start,start2;

begin
  fillscreen(177,8);
  cursor_off;
  bk :=4; { bk = background colour }
  
  asci_tekst(25, 3,'Ŀ',7,bk);
  asci_tekst(25, 4,' ¿ ',7,bk);
  asci_tekst(25, 5,'                        ',7,bk);
  asci_tekst(25, 6,'  ',7,bk);
  asci_tekst(25, 7,'    ',8,bk);
  asci_tekst(25, 8,'   ¿¿¿¿   ',7,bk);
  asci_tekst(25, 9,'    7  8  9  *    ',7,bk);
  asci_tekst(25,10,'      ',7,bk);
  asci_tekst(25,11,'   ¿¿¿¿   ',7,bk);
  asci_tekst(25,12,'    4  5  6  +    ',7,bk);
  asci_tekst(25,13,'      ',7,bk);
  asci_tekst(25,14,'   ¿¿¿¿   ',7,bk);
  asci_tekst(25,15,'    1  2  3  -    ',7,bk);
  asci_tekst(25,16,'      ',7,bk);
  asci_tekst(25,17,'   ¿¿¿¿   ',7,bk);
  asci_tekst(25,18,'    0  .  /  =    ',7,bk);
  asci_tekst(25,19,'      ',7,bk);
  asci_tekst(25,20,'    ',8,bk);
  asci_tekst(25,21,'',7,bk);

  asci_tekst(19,24,' C is clear / ESCAPE is exit calculator ',9,0);

  asci_tekst(31 , 9,'7',14,bk);asci_tekst(31 ,12,'4',14,bk);
  asci_tekst(31 ,15,'1',14,bk);asci_tekst(36, 9,'8',14,bk);
  asci_tekst(36,12,'5',14,bk);asci_tekst(36,15,'2',14,bk);
  asci_tekst(41, 9,'9',14,bk);asci_tekst(41,12,'6',14,bk);
  asci_tekst(41,15,'3',14,bk);asci_tekst(31 ,18,'0',14,bk);
  asci_tekst(46, 9,'*',15,bk);asci_tekst(46,12,'+',15,bk);
  asci_tekst(46,15,'-',15,bk);asci_tekst(36,18,'.',15,bk);
  asci_tekst(41,18,'/',15,bk);asci_tekst(46,18,'=',15,bk);

  

  {---------------------------------------------------------------}

  start2:

  asci_tekst(28,5,' 0                    ',15,0);
  x :=1;s :='';ss :='';getal_1 :=0;getal_2 :=0;totaal :=0;som :='';
  eindtotaal :=0;

  start:

  repeat
    ch :=upcase(readkey);

    if ch in[#48..#57] then begin
      getal :=ord(ch)-48;
      str(getal,s);
      insert(s,ss,x);
      asci_tekst(29,5,ss,15,0);
      val(ss,getal_1,q);
      inc(x);
    end;

    if ch =#46 then begin
      s :='.';insert(s,ss,x);            { decimal point }
      asci_tekst(29,5,ss,15,0);
      val(ss,getal_1,q);
      inc(x);
    end;
  until ch in[#27,#67,#43,#13,#42,#45,#47];

  if ch =#27 then exit;           { stop = escape }
  if ch =#67 then goto start2;    { clear = C }

  if ch =#43 then begin     { + }
    totaal :=totaal +getal_1;
    ascihor(28,5,20,32,15);
    s :='';ss :='';x :=1;
    som :='optel';
    goto start;
  end;

  if ch =#45 then begin     { - }
    getal_2 :=getal_1;
    ascihor(28,5,20,32,15);
    s :='';ss :='';x :=1;
    som :='aftre';
    goto start;
  end;

  if ch =#42 then begin    { * }
    if totaal =0 then totaal :=getal_1;
    ascihor(28,5,20,32,15);
    s :='';ss :='';x :=1;
    som :='verme';
    goto start;
  end;

  if ch =#47 then begin    { / }
    if totaal =0 then totaal :=getal_1;
    ascihor(28,5,20,32,15);
    s :='';ss :='';x :=1;
    som :='delen';
    goto start;
  end;

  if ch =#13 then begin
    if som ='optel' then totaal :=totaal +getal_1;
    if som ='aftre' then totaal :=totaal +(getal_2-getal_1);
    if som ='verme' then totaal :=totaal *getal_1;
    if (som ='delen') and (getal_1 >0) then totaal :=totaal /getal_1;
    ascihor(28,5,20,32,15);
    gotoxy(29,5);
    eindtotaal :=frac(totaal);
    if eindtotaal =0 then write(totaal:0:0)
      else write(totaal:0:6);
    s :='';ss :='';x :=1;
    getal_1 :=0;
    goto start;
  end;
  goto start;
end;

begin
  clrscr;
  calculator;
  cursor_on;
  halt;
end.
