 Program Functie_in_3D;
 (* nu met behulp van pointers om meer cordinaten te kunnen opslaan *)

 Uses Crt, Graph2, Graph, Dos;


 Type
   vl = array[1..4] of PointType;
   arr = array[1..180,1..180] of Integer;

 Var
   r, k, klr, nr, nr1, nr2 : Integer;
   p, po1, po2             : Point3d;
   v, lx, nx, t1, t2       : Integer;
   bereik, dx, dy          : Integer;
   f                       : Real;
   hx, hy                  : ^Arr;         (* hier is de pointer *)
   v1                      : vl;
   t                       : char;

 Function FNC(v1,v2: Real): Real;
 var
   r: Real;
 begin
   r   := sqrt(v1*v1 + v2*v2) * 3.14/180;
   fnc :=  v * sin(2*sqrt(abs(-cos(2*r)*r/2)));
 end;

 procedure hor;
 Begin
   t1 := 0;
   t2 := 0;
   Nr  := 210;
   Nr2 := -Nr;
   Dx := 6;
   Dy := 6;
   v := 85;
   Bereik := 120;
   F := Bereik / nr;
   r := 0;
   repeat
     inc(t1);
     t2 := 0;
     nr1 := -nr;
     p.x := nr2;
     p.y := nr1;
     p.z := FNC(p.x*f,p.y*f);
     po1 := p;
     Rotate(0,22,-45,po1);
     Transform(po1, hx^[t1,t2], hy^[t1,t2]);
     repeat
       inc(t2);
       p.y := nr1;
       p.z := FNC(p.x*f, p.y*f);
       po2 := p;
       Rotate(0,22,-45,po2);
       Transform(po1, hx^[t1,t2], hy^[t1,t2]);
       Lijn3(po1, po2, 15);
       po1 := po2;
       Inc(nr1,dy);
       if KeyPressed then Exit;
     until nr1 >= nr;
     Inc(nr2,dx);
   until nr2 >= nr;
 end;

 procedure drie;
 var a,b : integer;
 begin
   setcolor(1);
   for a := 2 to t2-1 do
     for b := 2 to t1-1 do
     begin
       v1[1].x := hx^[b,a] ; v1[1].y := hy^[b,a];
       v1[2].x := hx^[b,a+1] ; v1[2].y :=hy^[b,a+1];
       v1[3].x := hx^[b+1,a+1] ; v1[3].y :=hy^[b+1,a+1];
       v1[4].x := hx^[b+1,a] ; v1[4].y :=hy^[b+1,a];
       setfillstyle(1, 14);
       fillpoly(4, v1);
     end
 end;


 begin
   new(hx);
   new(hy);
   grmode(VGA256);
   initperspectief(false, 300);
   thebase.u := maxx div 2;
   thebase.v := maxy div 2;
   hor;
   t := readkey;
   grmode(vga256);
   thebase.u := maxx div 2;
   thebase.v := maxy div 2;
   drie;
   repeat
     if keypressed then t := readkey;
   until t = #32;
   exitgr;
 end.
