 PROGRAM Torus;

 USES Crt, Video, Math;

 Procedure Ring(Straal1, Straal2, A, B: Integer; var P: Point3D);
 Var
   S1, C1, S2, C2: Real;
 Begin

   Gonio(A , S1, C1);
   Gonio(B , S2, C2);

   P.X := (Straal1 + Straal2 * C1) * C2;
   P.Y := (Straal1 + Straal2 * C1) * S2;
   P.Z := Straal2 * S1

 End;


 Procedure Bereken(Straal1, Straal2, Kleur, PlusA, PlusB, Hx, Hy, Hz: Integer);
 Var
   P1, P2: Point3d;
   A, B  : Integer;
 Begin

   A := -180;

   repeat
     B := -180;
     Ring(Straal1, Straal2, A, B, P1);
     Rotate(Hx, Hy, Hz, P1);
     repeat
       Ring(Straal1, Straal2, A, B, P2);
       Rotate(Hx, Hy, Hz, P2);
       Lijn3( P1, P2, Kleur);
       P1 := P2;
       Inc(B, PlusB);
     until B > 180;
     Inc(A, PlusA);
   until A > 180;


   A := -180;

   repeat
     B := -180;
     Ring(Straal1, Straal2, B, A, P1);
     Rotate(Hx, Hy, Hz, P1);
     repeat
       Ring(Straal1, Straal2, B, A, P2);
       Rotate(Hx, Hy, Hz, P2);
       Lijn3( P1, P2, Kleur);
       P1 := P2;
       Inc(B, PlusB);
     until B > 180;
     Inc(A, PlusA);
   until A > 180;


 End;

 BEGIN
   GrMode(vga16);
   TheBase.U := MaxX div 2;
   TheBase.V := MaxY div 2;
   InitPerspectief(False, 0);
   Bereken(MaxX div 3, MaxY div 8, 14, 10, 10, -10, -30, 0);
   repeat until Keypressed;
   ExitGr;
 END.



