 (*************************************************************)
 (* tekent binaire bomen met random diepte en random hoeken   *)
 (* tussen de takken d.m.v recursieve procedure               *)
 (* datum: 25-12-1997                                         *)
 (* ***********************************************************)

 Program Tree;
 {$N+}
 Uses Crt, Graph2, Graph, Dos;

 Const
   Rad = 3.1415926/180;

 Var
   t : char;

 procedure Draw_Branch(x, y, hl, hr: integer; len, lvl: byte);
 var
   u1, u2, v1, v2, hld, hrd: integer;
 begin
   hl := hl mod 360;
   hr := hr mod 360;
   len := abs(len);
   if lvl > 0 then
   begin
     u1 := x + trunc(cos(hr*Rad)*len);
     v1 := y - trunc(sin(hr*Rad)*len);
     u2 := x + trunc(cos(hl*Rad)*len);
     v2 := y - trunc(sin(hl*Rad)*len);
     lijn(x, y, u1, v1, lvl*2+35);
     lijn(x, y, u2, v2, lvl*2+35);
     hld := random(55)+5;
     hrd := random(55)+5;
     Draw_Branch(u1, v1, hl-hrd, hr-hrd, len-trunc(len*0.20), lvl-1);
     Draw_Branch(u2, v2, hl+hld, hr+hld, len-trunc(len*0.20), lvl-1);
   end;
 end;


 begin
   grmode(VGA256);
   randomize;

   repeat
     lijn(320,380, 320,320, 19);
     draw_branch(320, 320, random(80)+90, random(75)+5,
                  random(25)+25, random(8)+5);

     t := #0;
     t := readkey;
     cleardevice;
   until t = #27;

   exitgr;
 end.
