 (*************************************************************)
 (* tekent n-aire bomen met random diepte en random hoeken    *)
 (* tussen de takken d.m.v recursieve procedure               *)
 (* datum: 25-12-1997                                         *)
 (* ***********************************************************)

 Program Tree2;
 {$N+}
 Uses Crt, Graph2, Graph, Dos;

 Const
   Rad = 3.1415926/180;

 Var
   t : char;

 procedure Draw_Branch(x, y, hl, hr: integer; len, lvl: byte);
 var
   u, v: array[1..7] of integer;
   i, nr, hk, hd, clr: integer;

 begin
   hl := hl mod 360;
   hr := hr mod 360;
   len := abs(len);
   if lvl > 0 then
   begin
     nr := random(3)+2;             (* aantal takken op deze splitsing *)
     if nr > 0 then
     begin
       for i := 1 to nr do
       begin
         if Odd(i) then
            hk := hr+(random(8)-8)
         else
            hk := hl+(random(8)-8);
         u[i] := x + trunc(cos(hk*Rad)*len);
         v[i] := y - trunc(sin(hk*Rad)*len);
         clr := lvl+16;
         lijn(x, y, u[i], v[i], clr);
         hd := random(35)+5;
         if odd(i) then
           Draw_Branch(u[i], v[i], hl-hd, hr-hd, len-trunc(len*0.15), lvl-1)
         else
           Draw_Branch(u[i], v[i], hl+hd, hr+hd, len-trunc(len*0.15), lvl-1);
       end;
     end;
   end;
 end;

 begin
   grmode(VGA256);
   randomize;

   repeat
     lijn(320,400, 320,300, 20);
     draw_branch(320, 300, random(55)+95, random(75)+2,
                  random(30)+30, random(5)+5);
    
     t := #0;
     if keypressed then t := readkey;
     delay(10000);
     cleardevice;
   until t = #27;

   exitgr;
 end.
