program triangle;

uses crt;

var
  rows :byte;
  ch   :char;

Procedure CalcPascalRow(r : Word);      { which row to calculate }

Var
  prows   : Array[0..1, 0..100] of Word;{ your two Arrays }
  thisrow,
  lastrow : Byte;                       { point to this row & last row }
  i, j    : Word;                       { counters }

begin
  lastrow := 0;                         { set up "which row is which" }
  thisrow := 1;
  prows[lastrow, 0] := 0;               { set up row "1": 0110 }
  prows[lastrow, 1] := 1;
  prows[lastrow, 2] := 1;
  prows[lastrow, 3] := 0;
  For j := 2 to r do
  begin  { generate each "line" starting w/2 }
    prows[thisrow, 0] := 0;
    For i := 1 to j + 1 do
    begin  { each "new" element = sum of "old" }
      prows[thisrow, i] :=   { element + predecessor to "old" }
        prows[lastrow, i] +  { element }
        prows[lastrow, i - 1];
    end;
    prows[thisrow, j + 2] := 0;
    lastrow := thisrow;                 { prepare For next iteration }
    thisrow := (thisrow + 1) mod 2;
  end;
  For i := 1 to r + 1 do Write(prows[lastrow, i] : 4,'  ');
  Writeln;
end;

label start;

begin
  start:
  clrscr;
  textcolor(11);
  gotoxy(4,2);write('How many rows ? ');
  readln(rows);
  textcolor(14);
  gotoxy(4,4);CalcPascalRow(rows);
  textcolor(7);
  gotoxy(4,18);write('Escape is stop / Space is next');
  repeat
    ch :=readkey;
  until ch in[#27,#32];
  if ch =#32 then goto start;
end.
