 (*************************************************************)
 (* tekent n-aire bomen met random diepte en random hoeken    *)
 (* tussen de takken d.m.v recursieve procedure               *)
 (* datum: 25-12-1997                                         *)
 (* ***********************************************************)

 Program Tree2;
 {$N+}
 Uses Crt, Graph2, Graph, Dos;

 Const
   Rad = 3.1415926/180;

 Var
   t : char;

 procedure Draw_Branch(x, y, hl, hr: integer; len, lvl: byte);
 var
   u, v: array[1..4] of integer;
   i, nr, hk, hd, clr: integer;

 begin
   hl := hl mod 360;
   hr := hr mod 360;
   len := abs(len);
   if lvl > 0 then
   begin
     nr := random(2)+2;               (* aantal takken op deze splitsing *)
     if nr > 0 then
     begin
       for i := 1 to nr do
       begin
         if Odd(i) then
           begin
             hk := hr+(random(5)-5);
             clr := 2
           end
         else
           begin
             hk := hl+(random(10)-10);
             clr := 10
           end;
         u[i] := x + trunc(cos(hk*Rad)*len);
         v[i] := y - trunc(sin(hk*Rad)*len);
         lijn(x, y, u[i], v[i], clr);
         hd := random(45)+5;
         if odd(i) then
           Draw_Branch(u[i], v[i], hl-hd, hr-hd, len-(random(3)+3), lvl-1)
         else
           Draw_Branch(u[i], v[i], hl+hd, hr+hd, len-(random(3)+3), lvl-1);
       end;
     end;
   end;
 end;

 begin
   grmode(VGA16);
   randomize;

   repeat
     lijn(320,380, 320,320, 6);
     (*draw_branch(320, 320, random(60)+95, random(65)+15,
                  random(20)+30, 6);   *)
     draw_branch(320, 320, 130, 40,
                  random(30)+30, 8);

     t := #0;
     if keypressed then t := readkey;
     delay(10000);
     cleardevice;
   until t = #27;

   exitgr;
 end.
